/* Copyright (c) 2000-2006 Wolfgang Hoermann and Josef Leydold */
/* Department of Statistics and Mathematics, WU Wien, Austria  */

#ifndef UNUR_FP_SOURCE_H_SEEN
#define UNUR_FP_SOURCE_H_SEEN
#define _unur_FP_same(a,b) \
 ((a)==(b) || \
 fabs((a)-(b)) <= ((fabs(a)<fabs(b))?fabs(a):fabs(b)) * DBL_EPSILON)
#define _unur_FP_equal(a,b) \
 ((a)==(b) || \
 fabs((a)-(b)) <= ((fabs(a)<fabs(b))?fabs(a):fabs(b)) * UNUR_EPSILON)
#define _unur_FP_approx(a,b) \
 ((a)==(b) || \
 fabs((a)-(b)) <= ((fabs(a)<fabs(b))?fabs(a):fabs(b)) * UNUR_SQRT_DBL_EPSILON)
#define _unur_FP_less(a,b) \
 (!_unur_FP_equal((a),(b)) && ((a) < (b)))
#define _unur_FP_greater(a,b) \
 (!_unur_FP_equal((a),(b)) && ((a) > (b)))
int _unur_isfinite (const double x);
int _unur_isnan (const double x);
int _unur_isinf (const double x);
#define _unur_FP_is_infinity(a)  ((a) >= INFINITY)
#define _unur_FP_is_minus_infinity(a)  ((a) <= -INFINITY)
#define _unur_FP_is_plusminus_infinity(a) (_unur_FP_is_infinity(a) || _unur_FP_is_minus_infinity(a))
#endif  
